#if defined(UNICODE) && !defined(_UNICODE)
  #define _UNICODE 1
#endif
#if !defined(UNICODE) && defined(_UNICODE)
  #define UNICODE 1
#endif
#define WIN32_LEAN_AND_MEAN
#define _CRTIMP __declspec(dllimport)
#include <windows.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>

#define _s(s) (sizeof(s)/sizeof(*(s)))

#if 0
HANDLE g_handle = (HANDLE)(size_t)STD_OUTPUT_HANDLE;
#else
#define g_handle (HANDLE)(size_t)STD_OUTPUT_HANDLE
#endif
int __cdecl xprintf(LPCTSTR format, ...)
{
#ifdef UNICODE
  TCHAR w[1000];
  CHAR a[2016];
#else
  CHAR a[4016];
  #define w a
#endif
  int n;
  va_list ap;
  va_start(ap, format);
  n = _vsntprintf(w, _s(w), format, ap);
  va_end(ap);
#ifdef UNICODE
  n = (int)wcstombs(a, w, _s(a));
#endif
  WriteFile(g_handle, a, (DWORD)n, (DWORD*)&n, NULL);
  return n;
#ifndef UNICODE
  #undef w
#endif
}

BOOL CALLBACK EnumResNameProc(HMODULE hModule, LPCTSTR lpszType, LPTSTR lpszName, LONG_PTR lParam)
{
  LPCTSTR pszType;
  LPTSTR pszName;
  HRSRC hResInfo;
  TCHAR Num[2][9];

  (void)lParam;

  pszType = lpszType;
  if(IS_INTRESOURCE(pszType))
  {
    _stprintf(Num[0], _T("%08X"), (WORD)(ULONG_PTR)lpszType);
    pszType = Num[0];
  }
  xprintf(_T("Type=%-8s"), pszType);

  pszName = lpszName;
  if(IS_INTRESOURCE(pszName))
  {
    _stprintf(Num[1], _T("%08X"), (WORD)(ULONG_PTR)lpszName);
    pszName = Num[1];
  }
  xprintf(_T(" Name=%-8s"), pszName);

  hResInfo = FindResource(hModule, lpszName, lpszType);
  if(NULL != hResInfo)
  {
    HGLOBAL hResData;
    DWORD Size;
    xprintf(_T(" hResInfo=%08X"), (ULONG)((size_t)hResInfo - ((size_t)hModule & ~1)));
    Size = SizeofResource(hModule, hResInfo);
    if(0 != Size)
    {
      xprintf(_T(" Size=%08X"), Size);
    }
    else
    {
      xprintf(_T(" SizeofResource failed! (%u)"), GetLastError());
    }
    hResData = LoadResource(hModule, hResInfo);
    if(NULL != hResData)
    {
      if(lParam)
      {
        HANDLE hFile;
        TCHAR ImageName[400];

        _stprintf(ImageName, _T("%s_%s_%s"), (LPCTSTR)lParam, pszType, pszName);
        hFile = CreateFile(ImageName, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL);
        if(INVALID_HANDLE_VALUE != hFile)
        {
          WriteFile(hFile, (LPCVOID)hResData, Size, &Size, NULL);
          CloseHandle(hFile);
        }
      }
      xprintf(_T(" hResData=%08X\r\n"), (ULONG)((size_t)hResData - ((size_t)hModule & ~1)));
    }
    else
    {
      xprintf(_T(" LoadResource failed! (%u)\r\n"), GetLastError());
    }
  }
  else
  {
    xprintf(_T(" FindResource failed! (%u)\r\n"), GetLastError());
  }
  return TRUE;
}

BOOL CALLBACK EnumResTypeProc(HMODULE hModule, LPTSTR lpszType, LONG_PTR lParam)
{
  EnumResourceNames(hModule, lpszType, EnumResNameProc, lParam);
  return TRUE;
}

int _tmain(int argc, TCHAR* _targv[])
{
  HMODULE hModule;
  LPTSTR pImageName;
  ULONG Options;
  /*TCHAR ImageName[MAX_PATH];*/

  if(1 >= argc)
  {
    return xprintf(_T("enumrsrc <imagename> [options]\r\n"));
  }

  Options = 0;
  if(2 < argc)
  {
    Options = _tcstoul(_targv[2], NULL, 0);
  }

  Label_Retry:
  hModule = LoadLibraryEx(_targv[1], NULL, (DWORD)(2 & Options ? DONT_RESOLVE_DLL_REFERENCES : LOAD_LIBRARY_AS_DATAFILE));
  if(NULL == hModule)
  {
    if(2 & Options)
    {
      Options &= ~2;
      goto Label_Retry;
    }
    return xprintf(_T("LoadLibraryEx failed! (%u)\r\n"), GetLastError());
  }
  pImageName = NULL;
  if(1 & Options)
  {
    /*GetModuleFileName(hModule, ImageName, _s(ImageName));*/
    pImageName = _targv[1]; /*ImageName;*/
  }
  if(!EnumResourceTypes(hModule, EnumResTypeProc, (LONG_PTR)pImageName))
  {
    return xprintf(_T("EnumResourceTypes failed! (%u)\r\n"), GetLastError());
  }
  FreeLibrary(hModule);
  return 0;
}


INT WINAPI ParseCommandLine(LPCTSTR lpInput, LPTSTR *argv, INT nargv, LPTSTR lpCommandLine, ULONG ccharCommandLine) {
  INT argc = 0;
  LPTSTR c = lpCommandLine;
  LPCTSTR p = lpInput;
  TCHAR s;

  while(ccharCommandLine-- && ((*c++ = *p++) != 0)) {}
  if((ccharCommandLine == 0) && *p) {
    return(0);
  }

  c = lpCommandLine;
  for(;;) {
    while(*c && (*c <= ' ')) {
      c++;
    }
    if(*c == '\0') {
      break;
    }
    s = (TCHAR)(*c == '"' ? *c++ : ' ');
    if(argc < nargv) {
      argv[argc++] = c;
    }
    while(*c && (*c != s)) {
      c++;
    }
    if(*c == '\0') {
      break;
    }
    *c++ = '\0';
  }

  return(argc);
}

#ifdef UNICODE
void wmainCRTStartup(void)
#else
void mainCRTStartup(void)
#endif
{
  TCHAR *_targv[3];
  TCHAR CommandLine[4016];
  ExitProcess((UINT)_tmain(ParseCommandLine(GetCommandLine(), _targv, (INT)_s(_targv), CommandLine, (ULONG)_s(CommandLine)), _targv));
}
